import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * // Oberflche zum gemeinsamen Test verschiedener Keller und Schlangen
    // R. Krell fr IFQ1M, 30.1.2013
  */

public class Q1_KuS_GUI extends JFrame {
  // Anfang Attribute
  char gewhlterTyp = ' ';
  Q1_SpeicherMitTyp speicher;     // Warnung, weil Elementtyp noch nicht festgelegt!

  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JButton jBtKommazahlen = new JButton();
  private JButton jBtZeichenketten = new JButton();
  private JLabel jLabel3 = new JLabel();
  private JButton jBtKellerR = new JButton();
  private JButton jBtKellerD = new JButton();
  private JButton jBtKellerZ = new JButton();
  private JButton jBtSchlangeZ = new JButton();
  private JLabel jLabel4 = new JLabel();
  private JTextField jTfEingabe = new JTextField();
  private JButton jBtRein = new JButton();
  private JButton jBtLeer = new JButton();
  private JButton jBtZeige = new JButton();
  private JButton jBtRaus = new JButton();
  private JScrollPane jScrollPane1 = new JScrollPane();
    private JTextArea jTaAusgabe = new JTextArea("");
  // Ende Attribute

  public Q1_KuS_GUI(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 983;
    int frameHeight = 334;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel1.setBounds(24, 16, 322, 24);
    jLabel1.setText("Testen von abstrakten Datenspeichern");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 17));
    cp.add(jLabel1);
    jLabel2.setBounds(24, 56, 86, 16);
    jLabel2.setText("Elementtyp:");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    jBtKommazahlen.setBounds(136, 56, 161, 25);
    jBtKommazahlen.setText("Kommazahlen");
    jBtKommazahlen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtKommazahlen_ActionPerformed(evt);
      }
    });
    cp.add(jBtKommazahlen);
    jBtZeichenketten.setBounds(328, 56, 153, 25);
    jBtZeichenketten.setText("Zeichenketten");
    jBtZeichenketten.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtZeichenketten_ActionPerformed(evt);
      }
    });
    cp.add(jBtZeichenketten);
    jLabel3.setBounds(24, 112, 91, 16);
    jLabel3.setText("Speichertyp:");
    jLabel3.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel3);
    jBtKellerR.setBounds(136, 112, 161, 25);
    jBtKellerR.setText("Keller m. Reihung");
    jBtKellerR.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtKellerR_ActionPerformed(evt);
      }
    });
    cp.add(jBtKellerR);
    jBtKellerD.setBounds(328, 112, 153, 25);
    jBtKellerD.setText("Keller m. Datei");
    jBtKellerD.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtKellerD_ActionPerformed(evt);
      }
    });
    cp.add(jBtKellerD);
    jBtKellerZ.setBounds(512, 112, 193, 25);
    jBtKellerZ.setText("Keller m. Knoten/Zeigern");
    jBtKellerZ.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtKellerZ_ActionPerformed(evt);
      }
    });
    cp.add(jBtKellerZ);
    jBtSchlangeZ.setBounds(512, 152, 193, 25);
    jBtSchlangeZ.setText("Schlange m. Knoten/Zeigern");
    jBtSchlangeZ.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtSchlangeZ_ActionPerformed(evt);
      }
    });
    cp.add(jBtSchlangeZ);
    jLabel4.setBounds(24, 208, 93, 16);
    jLabel4.setText("Operationen:");
    jLabel4.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel4);
    jTfEingabe.setBounds(136, 208, 129, 24);
    jTfEingabe.setText("jTfEingabe");
    cp.add(jTfEingabe);
    jBtRein.setBounds(280, 208, 81, 25);
    jBtRein.setText("rein");
    jBtRein.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtRein_ActionPerformed(evt);
      }
    });
    cp.add(jBtRein);
    jBtLeer.setBounds(400, 208, 81, 25);
    jBtLeer.setText("istLeer?");
    jBtLeer.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtLeer_ActionPerformed(evt);
      }
    });
    cp.add(jBtLeer);
    jBtZeige.setBounds(512, 208, 81, 25);
    jBtZeige.setText("zeige1");
    jBtZeige.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtZeige_ActionPerformed(evt);
      }
    });
    cp.add(jBtZeige);
    jBtRaus.setBounds(624, 208, 81, 25);
    jBtRaus.setText("raus");
    jBtRaus.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtRaus_ActionPerformed(evt);
      }
    });
    cp.add(jBtRaus);
    jScrollPane1.setBounds(24, 256, 681, 177);
    cp.add(jScrollPane1);
    jTaAusgabe.setBounds(-2, -2, 673, 177);
    jTaAusgabe.setText("(Strings)");
    jScrollPane1.setViewportView(jTaAusgabe);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jBtKommazahlen_ActionPerformed(ActionEvent evt) {
    gewhlterTyp = 'k'; // Kommazahl
    jTaAusgabe.setText("Knftig werden nur Kommazahlen gespeichert\n");
  }

  public void jBtZeichenketten_ActionPerformed(ActionEvent evt) {
    gewhlterTyp = 'z'; // Zeichenkette
    jTaAusgabe.setText("Knftig werden nur Zeichenketten (Texte) gespeichert\n");
  }

  public void jBtKellerR_ActionPerformed(ActionEvent evt) {
    switch (gewhlterTyp)
    {
      case 'k' : speicher = new Q1_RKeller<Double>();
                 jTaAusgabe.append("Neuer Keller mit Reihung fr Kommazahlen erzeugt\n"); break;
      case 'z' : speicher = new Q1_RKeller<String>();
                 jTaAusgabe.append("Neuer Keller mit Reihung fr Zeichenketten erzeugt\n"); break;
      default  : jTaAusgabe.append("* noch kein Elementtyp -- nichts erzeugt *\n");
    }
  }

  public void jBtKellerD_ActionPerformed(ActionEvent evt) {
    switch (gewhlterTyp)
    {
      case 'k' : speicher = new Q1_DKeller<Double>();
                 jTaAusgabe.append("Neuer Keller mit Dateien fr Kommazahlen erzeugt\n"); break;
      case 'z' : speicher = new Q1_DKeller<String>();
                 jTaAusgabe.append("Neuer Keller mit Dateien fr Zeichenketten erzeugt\n"); break;
      default  : jTaAusgabe.append("* noch kein Elementtyp -- nichts erzeugt *\n");
    }
  }

  public void jBtKellerZ_ActionPerformed(ActionEvent evt) {
    switch (gewhlterTyp)
    {
      case 'k' : speicher = new Q1_ZKeller<Double>();
                 jTaAusgabe.append("Neuer Keller mit Knoten fr Kommazahlen erzeugt\n"); break;
      case 'z' : speicher = new Q1_ZKeller<String>();
                 jTaAusgabe.append("Neuer Keller mit Knoten fr Zeichenketten erzeugt\n"); break;
      default  : jTaAusgabe.append("* noch kein Elementtyp -- nichts erzeugt *\n");
    }
  }

  public void jBtSchlangeZ_ActionPerformed(ActionEvent evt) {
    switch (gewhlterTyp)
    {
      case 'k' : speicher = new Q1_ZSchlange<Double>();
                 jTaAusgabe.append("Neue Schlange mit Knoten fr Kommazahlen erzeugt\n"); break;
      case 'z' : speicher = new Q1_ZSchlange<String>();
                 jTaAusgabe.append("Neue Schlange mit Knoten fr Zeichenketten erzeugt\n"); break;
      default  : jTaAusgabe.append("* noch kein Elementtyp -- nichts erzeugt *\n");
    }
  }

  public void jBtRein_ActionPerformed(ActionEvent evt) {
    switch (gewhlterTyp)
    {
      case 'k' : double zahl = Double.parseDouble(jTfEingabe.getText());
                 speicher.rein (zahl);
                 jTaAusgabe.append("Kommazahl "+zahl+" eingefgt\n"); break;
      case 'z' : String text = jTfEingabe.getText();
                 speicher.rein (text);
                 jTaAusgabe.append("Zeichenkette \""+text+"\" eingefgt\n"); break;
    }
  }

  public void jBtLeer_ActionPerformed(ActionEvent evt) {
    if (speicher.istLeer())
    {
      jTaAusgabe.append("Speicher ist leer -- zeige1 und raus unmglich!\n");
    }
    else
    {
      jTaAusgabe.append("Speicher ist nicht leer, sondern enthlt mind. ein Element\n");
    }
  }

  public void jBtZeige_ActionPerformed(ActionEvent evt) {
    jTaAusgabe.append("Das Element "+speicher.zeige1()+" steht oben bzw. vorne\n");
  }

  public void jBtRaus_ActionPerformed(ActionEvent evt) {
    jTaAusgabe.append("Das Element "+speicher.raus()+" wurde aus dem Speicher entfernt\n");
  }

  // Ende Methoden

  public static void main(String[] args) {
    Q1_KuS_GUI k = new Q1_KuS_GUI("Q1_KuS_GUI");
  }
}
